diff --git a/sound/soc/davinci/Kconfig b/sound/soc/davinci/Kconfig
index 6b732d8e5896..f1f0686acce4 100644
--- a/sound/soc/davinci/Kconfig
+++ b/sound/soc/davinci/Kconfig
@@ -1,40 +1,3 @@
-config SND_DAVINCI_SOC
-	tristate
-	depends on ARCH_DAVINCI
-	select SND_EDMA_SOC
-
-config SND_EDMA_SOC
-	tristate "SoC Audio for Texas Instruments chips using eDMA"
-	depends on TI_EDMA
-	select SND_SOC_GENERIC_DMAENGINE_PCM
-	help
-	  Say Y or M here if you want audio support for TI SoC which uses eDMA.
-	  The following line of SoCs are supported by this platform driver:
-	  - daVinci devices
-	  - AM335x
-	  - AM437x/AM438x
-	  - DRA7xx family
-
-config SND_DAVINCI_SOC_I2S
-	tristate "DaVinci Multichannel Buffered Serial Port (McBSP) support"
-	depends on SND_EDMA_SOC
-	help
-	  Say Y or M here if you want to have support for McBSP IP found in
-	  Texas Instruments DaVinci DA850 SoCs.
-
-config SND_DAVINCI_SOC_MCASP
-	tristate "Multichannel Audio Serial Port (McASP) support"
-	depends on SND_OMAP_SOC || SND_EDMA_SOC
-	help
-	  Say Y or M here if you want to have support for McASP IP found in
-	  various Texas Instruments SoCs like:
-	  - daVinci devices
-	  - Sitara line of SoCs (AM335x, AM438x, etc)
-	  - DRA7x devices
-
-config SND_DAVINCI_SOC_VCIF
-	tristate
-
 config SND_DAVINCI_SOC_GENERIC_EVM
 	tristate
 	select SND_SOC_TLV320AIC3X
diff --git a/sound/soc/davinci/Makefile b/sound/soc/davinci/Makefile
dissimilarity index 71%
index 23c6592eb31a..51b0d06e267b 100644
--- a/sound/soc/davinci/Makefile
+++ b/sound/soc/davinci/Makefile
@@ -1,16 +1,5 @@
-# SPDX-License-Identifier: GPL-2.0
-# DAVINCI Platform Support
-snd-soc-edma-objs := edma-pcm.o
-snd-soc-davinci-i2s-objs := davinci-i2s.o
-snd-soc-davinci-mcasp-objs:= davinci-mcasp.o
-snd-soc-davinci-vcif-objs:= davinci-vcif.o
-
-obj-$(CONFIG_SND_EDMA_SOC) += snd-soc-edma.o
-obj-$(CONFIG_SND_DAVINCI_SOC_I2S) += snd-soc-davinci-i2s.o
-obj-$(CONFIG_SND_DAVINCI_SOC_MCASP) += snd-soc-davinci-mcasp.o
-obj-$(CONFIG_SND_DAVINCI_SOC_VCIF) += snd-soc-davinci-vcif.o
-
-# Generic DAVINCI/AM33xx Machine Support
-snd-soc-evm-objs := davinci-evm.o
-
-obj-$(CONFIG_SND_DAVINCI_SOC_GENERIC_EVM) += snd-soc-evm.o
+# SPDX-License-Identifier: GPL-2.0
+# Generic DAVINCI/AM33xx Machine Support
+snd-soc-evm-objs := davinci-evm.o
+
+obj-$(CONFIG_SND_DAVINCI_SOC_GENERIC_EVM) += snd-soc-evm.o
diff --git a/sound/soc/platforms/Kconfig b/sound/soc/platforms/Kconfig
index 620d1f292246..c4ba367e41c4 100644
--- a/sound/soc/platforms/Kconfig
+++ b/sound/soc/platforms/Kconfig
@@ -4,4 +4,6 @@
 
 menu "Platform drivers"
 
+source "sound/soc/platforms/davinci/Kconfig"
+
 endmenu
diff --git a/sound/soc/platforms/Makefile b/sound/soc/platforms/Makefile
index f66554cd5c45..49629e238da9 100644
--- a/sound/soc/platforms/Makefile
+++ b/sound/soc/platforms/Makefile
@@ -1 +1,3 @@
 # SPDX-License-Identifier: GPL-2.0
+
+obj-y	+= davinci/
diff --git a/sound/soc/platforms/davinci/Kconfig b/sound/soc/platforms/davinci/Kconfig
new file mode 100644
index 000000000000..0a11b8f018ae
--- /dev/null
+++ b/sound/soc/platforms/davinci/Kconfig
@@ -0,0 +1,36 @@
+config SND_DAVINCI_SOC
+	tristate
+	depends on ARCH_DAVINCI
+	select SND_EDMA_SOC
+
+config SND_EDMA_SOC
+	tristate "SoC Audio for Texas Instruments chips using eDMA"
+	depends on TI_EDMA
+	select SND_SOC_GENERIC_DMAENGINE_PCM
+	help
+	  Say Y or M here if you want audio support for TI SoC which uses eDMA.
+	  The following line of SoCs are supported by this platform driver:
+	  - daVinci devices
+	  - AM335x
+	  - AM437x/AM438x
+	  - DRA7xx family
+
+config SND_DAVINCI_SOC_I2S
+	tristate "DaVinci Multichannel Buffered Serial Port (McBSP) support"
+	depends on SND_EDMA_SOC
+	help
+	  Say Y or M here if you want to have support for McBSP IP found in
+	  Texas Instruments DaVinci DA850 SoCs.
+
+config SND_DAVINCI_SOC_MCASP
+	tristate "Multichannel Audio Serial Port (McASP) support"
+	depends on SND_OMAP_SOC || SND_EDMA_SOC
+	help
+	  Say Y or M here if you want to have support for McASP IP found in
+	  various Texas Instruments SoCs like:
+	  - daVinci devices
+	  - Sitara line of SoCs (AM335x, AM438x, etc)
+	  - DRA7x devices
+
+config SND_DAVINCI_SOC_VCIF
+	tristate
diff --git a/sound/soc/davinci/Makefile b/sound/soc/platforms/davinci/Makefile
similarity index 76%
copy from sound/soc/davinci/Makefile
copy to sound/soc/platforms/davinci/Makefile
index 23c6592eb31a..8d7d8017d82b 100644
--- a/sound/soc/davinci/Makefile
+++ b/sound/soc/platforms/davinci/Makefile
@@ -9,8 +9,3 @@ obj-$(CONFIG_SND_EDMA_SOC) += snd-soc-edma.o
 obj-$(CONFIG_SND_DAVINCI_SOC_I2S) += snd-soc-davinci-i2s.o
 obj-$(CONFIG_SND_DAVINCI_SOC_MCASP) += snd-soc-davinci-mcasp.o
 obj-$(CONFIG_SND_DAVINCI_SOC_VCIF) += snd-soc-davinci-vcif.o
-
-# Generic DAVINCI/AM33xx Machine Support
-snd-soc-evm-objs := davinci-evm.o
-
-obj-$(CONFIG_SND_DAVINCI_SOC_GENERIC_EVM) += snd-soc-evm.o
diff --git a/sound/soc/davinci/davinci-i2s.c b/sound/soc/platforms/davinci/davinci-i2s.c
similarity index 100%
rename from sound/soc/davinci/davinci-i2s.c
rename to sound/soc/platforms/davinci/davinci-i2s.c
diff --git a/sound/soc/davinci/davinci-i2s.h b/sound/soc/platforms/davinci/davinci-i2s.h
similarity index 100%
rename from sound/soc/davinci/davinci-i2s.h
rename to sound/soc/platforms/davinci/davinci-i2s.h
diff --git a/sound/soc/davinci/davinci-mcasp.c b/sound/soc/platforms/davinci/davinci-mcasp.c
similarity index 100%
rename from sound/soc/davinci/davinci-mcasp.c
rename to sound/soc/platforms/davinci/davinci-mcasp.c
diff --git a/sound/soc/davinci/davinci-mcasp.h b/sound/soc/platforms/davinci/davinci-mcasp.h
similarity index 100%
rename from sound/soc/davinci/davinci-mcasp.h
rename to sound/soc/platforms/davinci/davinci-mcasp.h
diff --git a/sound/soc/davinci/davinci-vcif.c b/sound/soc/platforms/davinci/davinci-vcif.c
similarity index 100%
rename from sound/soc/davinci/davinci-vcif.c
rename to sound/soc/platforms/davinci/davinci-vcif.c
diff --git a/sound/soc/davinci/edma-pcm.c b/sound/soc/platforms/davinci/edma-pcm.c
similarity index 100%
rename from sound/soc/davinci/edma-pcm.c
rename to sound/soc/platforms/davinci/edma-pcm.c
diff --git a/sound/soc/davinci/edma-pcm.h b/sound/soc/platforms/davinci/edma-pcm.h
similarity index 100%
rename from sound/soc/davinci/edma-pcm.h
rename to sound/soc/platforms/davinci/edma-pcm.h